using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;

namespace Sudoku.Controls
{

	#region delegates
	public delegate void FilledEventHandler(object sender, FilledEventArgs e);
	public delegate void ClearEventHandler(object sender, ClearedEventArgs e);
	#endregion

	#region classes

	#region class Square
	/// <summary>
	/// Summary description for Square.
	/// </summary>
	internal class Square : System.Windows.Forms.UserControl
	{
		private System.Windows.Forms.GroupBox grpSudoku;
		private Sudoku.Controls.TextButton btn00;
		private Sudoku.Controls.TextButton btn22;
		private Sudoku.Controls.TextButton btn21;
		private Sudoku.Controls.TextButton btn20;
		private Sudoku.Controls.TextButton btn13;
		private Sudoku.Controls.TextButton btn11;
		private Sudoku.Controls.TextButton btn10;
		private Sudoku.Controls.TextButton btn02;
		private Sudoku.Controls.TextButton btn01;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		internal Square()
		{
			// This call is required by the Windows.Forms Form Designer.
			InitializeComponent();

			// TODO: Add any initialization after the InitComponent call

		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if( components != null )
					components.Dispose();
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.grpSudoku = new System.Windows.Forms.GroupBox();
			this.btn22 = new Sudoku.Controls.TextButton();
			this.btn21 = new Sudoku.Controls.TextButton();
			this.btn20 = new Sudoku.Controls.TextButton();
			this.btn13 = new Sudoku.Controls.TextButton();
			this.btn11 = new Sudoku.Controls.TextButton();
			this.btn10 = new Sudoku.Controls.TextButton();
			this.btn02 = new Sudoku.Controls.TextButton();
			this.btn01 = new Sudoku.Controls.TextButton();
			this.btn00 = new Sudoku.Controls.TextButton();
			this.grpSudoku.SuspendLayout();
			this.SuspendLayout();
			// 
			// grpSudoku
			// 
			this.grpSudoku.Controls.Add(this.btn22);
			this.grpSudoku.Controls.Add(this.btn21);
			this.grpSudoku.Controls.Add(this.btn20);
			this.grpSudoku.Controls.Add(this.btn13);
			this.grpSudoku.Controls.Add(this.btn11);
			this.grpSudoku.Controls.Add(this.btn10);
			this.grpSudoku.Controls.Add(this.btn02);
			this.grpSudoku.Controls.Add(this.btn01);
			this.grpSudoku.Controls.Add(this.btn00);
			this.grpSudoku.Location = new System.Drawing.Point(0, -4);
			this.grpSudoku.Name = "grpSudoku";
			this.grpSudoku.Size = new System.Drawing.Size(128, 128);
			this.grpSudoku.TabIndex = 23;
			this.grpSudoku.TabStop = false;
			// 
			// btn22
			// 
			this.btn22.BackColor = System.Drawing.SystemColors.Control;
			this.btn22.Column = ((System.Byte)(2));
			this.btn22.Location = new System.Drawing.Point(88, 90);
			this.btn22.Name = "btn22";
			this.btn22.Number = "";
			this.btn22.Row = ((System.Byte)(2));
			this.btn22.Size = new System.Drawing.Size(32, 32);
			this.btn22.TabIndex = 8;
			this.btn22.TabStop = false;
			this.btn22.Filled += new Sudoku.Controls.tbFilledEventHandler(this.TextButton_Filled);
			this.btn22.Cleared += new Sudoku.Controls.tbClearedEventHandler(this.TextButton_Cleared);
			// 
			// btn21
			// 
			this.btn21.Column = ((System.Byte)(1));
			this.btn21.Location = new System.Drawing.Point(48, 90);
			this.btn21.Name = "btn21";
			this.btn21.Number = "";
			this.btn21.Row = ((System.Byte)(2));
			this.btn21.Size = new System.Drawing.Size(32, 32);
			this.btn21.TabIndex = 7;
			this.btn21.TabStop = false;
			this.btn21.Filled += new Sudoku.Controls.tbFilledEventHandler(this.TextButton_Filled);
			this.btn21.Cleared += new Sudoku.Controls.tbClearedEventHandler(this.TextButton_Cleared);
			// 
			// btn20
			// 
			this.btn20.Column = ((System.Byte)(0));
			this.btn20.Location = new System.Drawing.Point(8, 90);
			this.btn20.Name = "btn20";
			this.btn20.Number = "";
			this.btn20.Row = ((System.Byte)(2));
			this.btn20.Size = new System.Drawing.Size(32, 32);
			this.btn20.TabIndex = 6;
			this.btn20.TabStop = false;
			this.btn20.Filled += new Sudoku.Controls.tbFilledEventHandler(this.TextButton_Filled);
			this.btn20.Cleared += new Sudoku.Controls.tbClearedEventHandler(this.TextButton_Cleared);
			// 
			// btn13
			// 
			this.btn13.Column = ((System.Byte)(2));
			this.btn13.Location = new System.Drawing.Point(88, 50);
			this.btn13.Name = "btn13";
			this.btn13.Number = "";
			this.btn13.Row = ((System.Byte)(1));
			this.btn13.Size = new System.Drawing.Size(32, 32);
			this.btn13.TabIndex = 5;
			this.btn13.TabStop = false;
			this.btn13.Filled += new Sudoku.Controls.tbFilledEventHandler(this.TextButton_Filled);
			this.btn13.Cleared += new Sudoku.Controls.tbClearedEventHandler(this.TextButton_Cleared);
			// 
			// btn11
			// 
			this.btn11.Column = ((System.Byte)(1));
			this.btn11.Location = new System.Drawing.Point(48, 50);
			this.btn11.Name = "btn11";
			this.btn11.Number = "";
			this.btn11.Row = ((System.Byte)(1));
			this.btn11.Size = new System.Drawing.Size(32, 32);
			this.btn11.TabIndex = 4;
			this.btn11.TabStop = false;
			this.btn11.Filled += new Sudoku.Controls.tbFilledEventHandler(this.TextButton_Filled);
			this.btn11.Cleared += new Sudoku.Controls.tbClearedEventHandler(this.TextButton_Cleared);
			// 
			// btn10
			// 
			this.btn10.Column = ((System.Byte)(0));
			this.btn10.Location = new System.Drawing.Point(8, 50);
			this.btn10.Name = "btn10";
			this.btn10.Number = "";
			this.btn10.Row = ((System.Byte)(1));
			this.btn10.Size = new System.Drawing.Size(32, 32);
			this.btn10.TabIndex = 3;
			this.btn10.TabStop = false;
			this.btn10.Filled += new Sudoku.Controls.tbFilledEventHandler(this.TextButton_Filled);
			this.btn10.Cleared += new Sudoku.Controls.tbClearedEventHandler(this.TextButton_Cleared);
			// 
			// btn02
			// 
			this.btn02.Column = ((System.Byte)(2));
			this.btn02.Location = new System.Drawing.Point(88, 12);
			this.btn02.Name = "btn02";
			this.btn02.Number = "";
			this.btn02.Row = ((System.Byte)(0));
			this.btn02.Size = new System.Drawing.Size(32, 32);
			this.btn02.TabIndex = 2;
			this.btn02.TabStop = false;
			this.btn02.Filled += new Sudoku.Controls.tbFilledEventHandler(this.TextButton_Filled);
			this.btn02.Cleared += new Sudoku.Controls.tbClearedEventHandler(this.TextButton_Cleared);
			// 
			// btn01
			// 
			this.btn01.Column = ((System.Byte)(1));
			this.btn01.Location = new System.Drawing.Point(48, 12);
			this.btn01.Name = "btn01";
			this.btn01.Number = "";
			this.btn01.Row = ((System.Byte)(0));
			this.btn01.Size = new System.Drawing.Size(32, 32);
			this.btn01.TabIndex = 1;
			this.btn01.TabStop = false;
			this.btn01.Filled += new Sudoku.Controls.tbFilledEventHandler(this.TextButton_Filled);
			this.btn01.Cleared += new Sudoku.Controls.tbClearedEventHandler(this.TextButton_Cleared);
			// 
			// btn00
			// 
			this.btn00.Column = ((System.Byte)(0));
			this.btn00.Location = new System.Drawing.Point(8, 12);
			this.btn00.Name = "btn00";
			this.btn00.Number = "";
			this.btn00.Row = ((System.Byte)(0));
			this.btn00.Size = new System.Drawing.Size(32, 32);
			this.btn00.TabIndex = 0;
			this.btn00.TabStop = false;
			this.btn00.Filled += new Sudoku.Controls.tbFilledEventHandler(this.TextButton_Filled);
			this.btn00.Cleared += new Sudoku.Controls.tbClearedEventHandler(this.TextButton_Cleared);
			// 
			// Square
			// 
			this.Controls.Add(this.grpSudoku);
			this.Name = "Square";
			this.Size = new System.Drawing.Size(128, 128);
			this.Resize += new System.EventHandler(this.Square_Resize);
			this.grpSudoku.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		#region private variables
		private byte _Row = 0;
		private byte _Column = 0;
		#endregion

		#region properties
		public Control.ControlCollection SquareTextButtons
		{
			get { return grpSudoku.Controls; }
		}

		public byte Row
		{
			get { return _Row; }
			set { _Row = value; }
		}

		public byte Column
		{
			get { return _Column; }
			set { _Column = value; }
		}

		#endregion

		#region events
		public event FilledEventHandler Filled;
		public event ClearEventHandler Cleared;
		#endregion

		#region event - handling
		private void Square_Resize(object sender, System.EventArgs e)
		{
			this.Size=new System.Drawing.Size(128,128);
		}

		private void TextButton_Filled(object sender, Sudoku.Controls.KeyDownEventArgs e)
		{
			TextButton Sdr = (TextButton)sender;

			// Controleer of de andere vakken het nieuwe nummer niet hebben.
			foreach (TextButton ctl in grpSudoku.Controls)
			{
				if (ctl.Name != Sdr.Name)
				{
					if (ctl.HasNumber && !ctl.NumberIsActive(e.NewNumber))
					{ e.Invalid = true; }
				}
			}

			if (!e.Invalid) 
			{
				// Event
				FilledEventArgs fea = new FilledEventArgs();
	
				fea.Row = Sdr.Row;
				fea.Column = Sdr.Column;
				fea.newNumber = e.NewNumber;
	
				Filled(this, fea);

				e.Invalid=fea.Invalid;
			}
		}

		private void TextButton_Cleared(object sender, Sudoku.Controls.KeyDownEventArgs e)
		{
			TextButton Sdr = (TextButton)sender;
			ClearedEventArgs cea = new ClearedEventArgs();

			cea.Row = Sdr.Row;
			cea.Column = Sdr.Column;

			Cleared(this, cea);	
		}
		#endregion

	}
	#endregion

	#region class FilledEventArgs
	public class FilledEventArgs : BaseEventArgs
	{
		private bool _Invalid;
		private string _newNumber;
		
		public string newNumber
		{
			get { return _newNumber; }
			set { _newNumber = value; }
		}

		public bool Invalid
		{
			get { return _Invalid; }
			set { _Invalid = value; }
		}
	}
	#endregion

	#region class ClearedEventArgs
	public class ClearedEventArgs : BaseEventArgs
	{
	}
	#endregion

	#region class BaseEventArgs
    public class BaseEventArgs : EventArgs
	{
		private byte _Row;
		private byte _Column;

		public byte Row
		{
			get { return _Row; }
			set { _Row = value; }
		}

		public byte Column
		{
			get { return _Column; }
			set { _Column = value; }
		}
	}
	#endregion

	#endregion

}
